/* null-int.c - does nothing ... */

#ifndef	lint
static char *rcsid = "$Header: /a/vulcan/xtel/isode/isode-master/dsap/common/RCS/null_int.c,v 8.0 91/07/17 12:25:34 isode Rel $";
#endif

/* 
 * $Header: /a/vulcan/xtel/isode/isode-master/dsap/common/RCS/null_int.c,v 8.0 91/07/17 12:25:34 isode Rel $
 *
 *
 * $Log:	null_int.c,v $
 * Revision 8.0  91/07/17  12:25:34  isode
 * Release 7.0
 * 
 * 
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#include "manifest.h"
#include "general.h"

typedef caddr_t NullEncrypted;
typedef caddr_t NullPublicKey;
typedef caddr_t NullParameters;
typedef caddr_t NullSecretKey;
typedef caddr_t NullHash;

/* ARGSUSED */
int null_encrypt(in, out, key, parms)
NullEncrypted *in;
NullEncrypted **out;
NullPublicKey *key;
NullParameters *parms;
{
  return (OK);
}

/* ARGSUSED */
int null_decrypt(in, out, key, parms)
NullEncrypted *in;
NullEncrypted **out;
NullSecretKey *key;
NullParameters *parms;
{
  return (OK);
}

/* ARGSUSED */
int null_read_secret_key(in, out, parms)
char *in;
NullSecretKey **out;
NullParameters **parms;
{
  return (OK);
}

/* ARGSUSED */
int null_write_secret_key(in, out, parms)
NullSecretKey *in;
char *out;
NullParameters *parms;
{
  return (OK);
}

/* ARGSUSED */
int null_read_public_key(in, out, parms)
char *in;
NullPublicKey **out;
NullParameters **parms;
{
  return (OK);
}

/* ARGSUSED */
int null_write_public_key(in, out, parms)
NullPublicKey *in;
char *out;
NullParameters *parms;
{
  return (OK);
}

/* ARGSUSED */
int null_pack_public_key(in, out, len, parms)
NullPublicKey *in;
char **out;
int *len;
NullParameters *parms;
{
  return (OK);
}

/* ARGSUSED */
int null_unpack_public_key(in, out, parms)
char *in;
NullPublicKey **out;
NullParameters **parms;
{
  return (OK);
}

/* ARGSUSED */
int null_pack_secret_key(in, out, len, parms)
NullPublicKey *in;
char **out;
int *len;
NullParameters *parms;
{
  return (OK);
}

/* ARGSUSED */
int null_unpack_secret_key(in, out, parms)
char *in;
NullSecretKey **out;
NullParameters **parms;
{
  return (OK);
}

/* ARGSUSED */
int null_free_encrypted(in)
NullEncrypted *in;
{
  return (OK);
}

/* ARGSUSED */
int null_get_blocksize(parms)
NullParameters *parms;
{
  return (512);
}

/* ARGSUSED */
int null_pack_encrypted(in, out, len, parms)
NullEncrypted *in;
char **out;
int *len;
NullParameters *parms;
{
char *result;

  result = (char *)calloc(1, 64);
  *out = result;
  *len = 512;
  return (OK);
}

/* ARGSUSED */
int null_unpack_encrypted(in, out, parms)
char *in;
NullEncrypted **out;
NullParameters *parms;
{
  return (OK);
}

/* ARGSUSED */
int null_init_hash(hash, key, parms)
NullHash **hash;
NullPublicKey *key;
NullParameters *parms;
{
  (*hash) = (NullHash *) 0;
   return (OK);
}

/* ARGSUSED */
int null_hash_block(hash, cp, key, parms)
NullHash *hash;
char *cp;
NullPublicKey *key;
NullParameters *parms;
{
  return (OK);
}

/* ARGSUSED */
int null_hash_short_block(hash, cp, len, key, parms)
NullHash *hash;
char *cp;
int len;
NullPublicKey *key;
NullParameters *parms;
{
  return (OK);
}

/* ARGSUSED */
int null_terminate_hash(hash)
NullHash *hash;
{
  return (OK);
}

/* ARGSUSED */
int null_compare_hash(a, b)
NullHash *a;
NullHash *b;
{
  return (OK);
}

/* ARGSUSED */
int null_pack_hash(in, out, len, parms)
NullHash *in;
char **out;
int *len;
NullParameters *parms;
{
char *result;

  result = (char *) calloc(1, 64);
  *out = result;
  *len = 512;
  return (OK);
}

/* ARGSUSED */
int null_unpack_hash(in, out, parms)
char *in;
NullHash **out;
NullParameters *parms;
{
  return (OK);
}

/* ARGSUSED */
int null_free_hash(hash)
NullHash *hash;
{
  return (OK);
}

